﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
'v1.00
Sub Class_Globals
	Public SharedFolder As String
	Public UseFileProvider As Boolean
End Sub

Public Sub Initialize
	Dim p As Phone
	If p.SdkVersion >= 24 Or File.ExternalWritable = False Then
		UseFileProvider = True
		SharedFolder = File.Combine(File.DirInternal, "shared")
	Else
		UseFileProvider = False
		SharedFolder = Starter.RuntimePermissions1.GetSafeDirDefaultExternal("shared")	'	works
		'	SharedFolder = File.Combine(File.DirInternal, "shared")	'	fails
	End If
	
	If Not(File.Exists("", SharedFolder)) Then
		File.MakeDir("", SharedFolder)
	End If
	
	Log($"Using FileProvider? ${UseFileProvider}"$)
	Log($"SharedFolder: ${SharedFolder}"$)
End Sub

Public Sub GetFileUri (FileName As String) As Object
	If UseFileProvider = False Then
		Dim uri As JavaObject
		Return uri.InitializeStatic("android.net.Uri").RunMethod("parse", Array("file://" & File.Combine(SharedFolder, FileName)))
	Else
		Dim f As JavaObject
		f.InitializeNewInstance("java.io.File", Array(SharedFolder, FileName))
		Dim fp As JavaObject
		Dim context As JavaObject
		context.InitializeContext
		fp.InitializeStatic("android.support.v4.content.FileProvider")
		Return fp.RunMethod("getUriForFile", Array(context, Application.PackageName & ".provider", f))
	End If
End Sub

Public Sub SetFileUriAsIntentData (Intent1 As Intent, FileName As String, MimeType As String)
	Dim jo As JavaObject = Intent1
	jo.RunMethod("setDataAndType", Array As Object(GetFileUri(FileName), MimeType))
	Intent1.Flags = Bit.Or(Intent1.Flags, 1) 'FLAG_GRANT_READ_URI_PERMISSION
End Sub